Subject: Re: How to build the kernel without any optimization?

From: Nicholas Mc Guire <[email-masked]>
Date: Sat, 21 Aug 2010 09:31:16 +0200

On Fri, 20 Aug 2010, Shawn Jin wrote:

> Hi,
> 
> I'm tracing the execution of ds1307_probe() and find that some of
> variables or function arguments cannot be printed in gdb because they
> are optimized out or not in the current context. This really gives
> some headache. Is there a way to build the kernel without any
> optimization? What gcc option shall I disable or add?
> 
> I already added the following to arch/powerpc/Makefile.
> 
> # Prevent GDB from jumping around in the code when trying to single step
> ifeq ($(CONFIG_DEBUG_KERNEL),y)
> KBUILD_CFLAGS           += -fno-schedule-insns -fno-schedule-insns2
> endif
>

much of the kernel can not be build without optimization - what you 
can do though is slectively try to disable optimization for specific
files by putting 

 CFLAGS_REMOVE_objfilenam.o = -SOME_OPT

in the Makefile. I think that is safer than what you did above as this would
always depend on the order of options that ultimately get passed to gcc.

hofrat